diff --git a/platform/linux-keystone2/Makefile.am b/platform/linux-keystone2/Makefile.am
index f72b350..638b903 100644
--- a/platform/linux-keystone2/Makefile.am
+++ b/platform/linux-keystone2/Makefile.am
@@ -9,57 +9,123 @@ include $(top_srcdir)/platform/Makefile.inc
 include Makefile.inc
 
 AM_CFLAGS +=  -I$(srcdir)/include
-AM_CFLAGS +=  -I$(srcdir)/include/api
+AM_CFLAGS +=  -I$(top_srcdir)/include
 AM_CFLAGS +=  -I$(top_srcdir)/platform/linux-generic/include
-AM_CFLAGS +=  -I$(top_srcdir)/platform/linux-generic/include/api
 AM_CFLAGS +=  -I$(top_srcdir)/helper/include
+
 KS2_LIBS = -lnwalsa_$(KS2_DEVICE) -lpktlib -lpa -lsa -lcppi_$(KS2_DEVICE) -lqmss_$(KS2_DEVICE) -lrm -lhplib_$(KS2_DEVICE)
 LIBS += $(KS2_LIBS)
+linux_generic_srcdir = $(top_srcdir)/platform/linux-generic
 
 include_HEADERS = \
-		  $(srcdir)/include/api/odp_buffer.h \
-		  $(srcdir)/include/api/odp_buffer_pool.h \
-		  $(srcdir)/include/api/odp_crypto.h \
-		  $(srcdir)/include/api/odp_packet.h \
-		  $(srcdir)/include/api/odp_packet_io.h \
-		  $(srcdir)/include/api/odp_state.h \
-		  $(srcdir)/include/api/odp_ti_mcsdk.h \
-		  $(srcdir)/include/api/mcsdk_tune.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_align.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_atomic.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_barrier.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_byteorder.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_compiler.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_config.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_coremask.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_debug.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_hints.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_init.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_packet_flags.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_queue.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_rwlock.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_schedule.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_shared_memory.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_spinlock.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_std_types.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_sync.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_system_info.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_thread.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_ticketlock.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_time.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_timer.h \
-		  $(top_srcdir)/platform/linux-generic/include/api/odp_version.h
+		  $(top_srcdir)/include/odp.h
+
+odpincludedir= $(includedir)/odp
+odpinclude_HEADERS = \
+		  $(srcdir)/include/odp/buffer.h \
+		  $(srcdir)/include/odp/buffer_pool.h \
+		  $(srcdir)/include/odp/crypto.h \
+		  $(srcdir)/include/odp/packet_io.h \
+		  $(srcdir)/include/odp/packet.h \
+		  $(linux_generic_srcdir)/include/odp/align.h \
+		  $(linux_generic_srcdir)/include/odp/atomic.h \
+		  $(linux_generic_srcdir)/include/odp/barrier.h \
+		  $(linux_generic_srcdir)/include/odp/byteorder.h \
+		  $(linux_generic_srcdir)/include/odp/compiler.h \
+		  $(linux_generic_srcdir)/include/odp/config.h \
+		  $(linux_generic_srcdir)/include/odp/cpu.h \
+		  $(linux_generic_srcdir)/include/odp/cpumask.h \
+		  $(linux_generic_srcdir)/include/odp/debug.h \
+		  $(linux_generic_srcdir)/include/odp/errno.h \
+		  $(linux_generic_srcdir)/include/odp/event.h \
+		  $(linux_generic_srcdir)/include/odp/hints.h \
+		  $(linux_generic_srcdir)/include/odp/init.h \
+		  $(linux_generic_srcdir)/include/odp/random.h \
+		  $(linux_generic_srcdir)/include/odp/packet_flags.h \
+		  $(linux_generic_srcdir)/include/odp/queue.h \
+		  $(linux_generic_srcdir)/include/odp/rwlock.h \
+		  $(linux_generic_srcdir)/include/odp/schedule.h \
+		  $(linux_generic_srcdir)/include/odp/shared_memory.h \
+		  $(linux_generic_srcdir)/include/odp/spinlock.h \
+		  $(linux_generic_srcdir)/include/odp/std_types.h \
+		  $(linux_generic_srcdir)/include/odp/sync.h \
+		  $(linux_generic_srcdir)/include/odp/system_info.h \
+		  $(linux_generic_srcdir)/include/odp/thread.h \
+		  $(linux_generic_srcdir)/include/odp/ticketlock.h \
+		  $(linux_generic_srcdir)/include/odp/time.h \
+		  $(linux_generic_srcdir)/include/odp/timer.h \
+		  $(linux_generic_srcdir)/include/odp/version.h
+
+odpplatincludedir = $(includedir)/odp/plat
+odpplatinclude_HEADERS = \
+		  $(srcdir)/include/odp/plat/mcsdk_tune.h \
+		  $(srcdir)/include/odp/plat/state.h \
+		  $(srcdir)/include/odp/plat/ti_mcsdk.h \
+		  $(linux_generic_srcdir)/include/odp/plat/atomic_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/buffer_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/byteorder_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/classification_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/cpumask_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/crypto_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/event_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/packet_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/packet_io_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/pool_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/queue_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/schedule_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/shared_memory_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/strong_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/timer_types.h \
+		  $(linux_generic_srcdir)/include/odp/plat/version_types.h
+
+odpapiincludedir= $(includedir)/odp/api
+odpapiinclude_HEADERS = \
+		  $(top_srcdir)/include/odp/api/align.h \
+		  $(top_srcdir)/include/odp/api/atomic.h \
+		  $(top_srcdir)/include/odp/api/barrier.h \
+		  $(top_srcdir)/include/odp/api/buffer.h \
+		  $(top_srcdir)/include/odp/api/byteorder.h \
+		  $(top_srcdir)/include/odp/api/classification.h \
+		  $(top_srcdir)/include/odp/api/compiler.h \
+		  $(top_srcdir)/include/odp/api/config.h \
+		  $(top_srcdir)/include/odp/api/cpu.h \
+		  $(top_srcdir)/include/odp/api/cpumask.h \
+		  $(top_srcdir)/include/odp/api/crypto.h \
+		  $(top_srcdir)/include/odp/api/debug.h \
+		  $(top_srcdir)/include/odp/api/errno.h \
+		  $(top_srcdir)/include/odp/api/event.h \
+		  $(top_srcdir)/include/odp/api/hints.h \
+		  $(top_srcdir)/include/odp/api/init.h \
+		  $(top_srcdir)/include/odp/api/packet.h \
+		  $(top_srcdir)/include/odp/api/packet_flags.h \
+		  $(top_srcdir)/include/odp/api/packet_io.h \
+		  $(top_srcdir)/include/odp/api/pool.h \
+		  $(top_srcdir)/include/odp/api/queue.h \
+		  $(top_srcdir)/include/odp/api/random.h \
+		  $(top_srcdir)/include/odp/api/rwlock.h \
+		  $(top_srcdir)/include/odp/api/schedule.h \
+		  $(top_srcdir)/include/odp/api/shared_memory.h \
+		  $(top_srcdir)/include/odp/api/spinlock.h \
+		  $(top_srcdir)/include/odp/api/std_types.h \
+		  $(top_srcdir)/include/odp/api/sync.h \
+		  $(top_srcdir)/include/odp/api/system_info.h \
+		  $(top_srcdir)/include/odp/api/thread.h \
+		  $(top_srcdir)/include/odp/api/ticketlock.h \
+		  $(top_srcdir)/include/odp/api/time.h \
+		  $(top_srcdir)/include/odp/api/timer.h \
+		  $(top_srcdir)/include/odp/api/version.h
 
-subdirheadersdir = $(includedir)/helper
+subdirheadersdir = $(includedir)/odp/helper
 subdirheaders_HEADERS = \
-			$(top_srcdir)/helper/include/odph_chksum.h \
-			$(top_srcdir)/helper/include/odph_eth.h \
-			$(top_srcdir)/helper/include/odph_ip.h \
-			$(top_srcdir)/helper/include/odph_linux.h \
-			$(top_srcdir)/helper/include/odph_packet.h \
-			$(top_srcdir)/helper/include/odph_ring.h \
-			$(top_srcdir)/helper/include/odph_udp.h
+			$(top_srcdir)/helper/include/odp/helper/chksum.h \
+			$(top_srcdir)/helper/include/odp/helper/eth.h \
+			$(top_srcdir)/helper/include/odp/helper/icmp.h \
+			$(top_srcdir)/helper/include/odp/helper/ip.h \
+			$(top_srcdir)/helper/include/odp/helper/ipsec.h \
+			$(top_srcdir)/helper/include/odp/helper/linux.h \
+			$(top_srcdir)/helper/include/odp/helper/ring.h \
+			$(top_srcdir)/helper/include/odp/helper/tcp.h \
+			$(top_srcdir)/helper/include/odp/helper/udp.h
 
 __LIB__libodp_la_SOURCES = \
 			   odp_buffer.c \
diff --git a/platform/linux-keystone2/include/api/odp_buffer.h b/platform/linux-keystone2/include/odp/buffer.h
similarity index 100%
rename from platform/linux-keystone2/include/api/odp_buffer.h
rename to platform/linux-keystone2/include/odp/buffer.h
diff --git a/platform/linux-keystone2/include/api/odp_buffer_pool.h b/platform/linux-keystone2/include/odp/buffer_pool.h
similarity index 100%
rename from platform/linux-keystone2/include/api/odp_buffer_pool.h
rename to platform/linux-keystone2/include/odp/buffer_pool.h
diff --git a/platform/linux-keystone2/include/api/odp_crypto.h b/platform/linux-keystone2/include/odp/crypto.h
similarity index 100%
rename from platform/linux-keystone2/include/api/odp_crypto.h
rename to platform/linux-keystone2/include/odp/crypto.h
diff --git a/platform/linux-keystone2/include/api/odp_packet.h b/platform/linux-keystone2/include/odp/packet.h
similarity index 100%
rename from platform/linux-keystone2/include/api/odp_packet.h
rename to platform/linux-keystone2/include/odp/packet.h
diff --git a/platform/linux-keystone2/include/api/odp_packet_io.h b/platform/linux-keystone2/include/odp/packet_io.h
similarity index 100%
rename from platform/linux-keystone2/include/api/odp_packet_io.h
rename to platform/linux-keystone2/include/odp/packet_io.h
diff --git a/platform/linux-keystone2/include/api/mcsdk_tune.h b/platform/linux-keystone2/include/odp/plat/mcsdk_tune.h
similarity index 100%
rename from platform/linux-keystone2/include/api/mcsdk_tune.h
rename to platform/linux-keystone2/include/odp/plat/mcsdk_tune.h
diff --git a/platform/linux-keystone2/include/api/odp_state.h b/platform/linux-keystone2/include/odp/plat/state.h
similarity index 100%
rename from platform/linux-keystone2/include/api/odp_state.h
rename to platform/linux-keystone2/include/odp/plat/state.h
diff --git a/platform/linux-keystone2/include/api/odp_ti_mcsdk.h b/platform/linux-keystone2/include/odp/plat/ti_mcsdk.h
similarity index 98%
rename from platform/linux-keystone2/include/api/odp_ti_mcsdk.h
rename to platform/linux-keystone2/include/odp/plat/ti_mcsdk.h
index 6dd0dd1..aa7e64f 100644
--- a/platform/linux-keystone2/include/api/odp_ti_mcsdk.h
+++ b/platform/linux-keystone2/include/odp/plat/ti_mcsdk.h
@@ -17,6 +17,7 @@ extern "C" {
 #include <ti/runtime/hplib/hplib.h>
 #include <ti/runtime/pktlib/pktlib.h>
 #include <ti/drv/nwal/nwal.h>
+#include <ti/drv/nwal/nwal_util.h>
 #include <ti/drv/nwal/nwal_osal.h>
 #include <mcsdk_tune.h>
 